CON

  BUF_SIZE      = 128
  LF            = $0a
  CR            = $0d
  QU            = $22
  
  #0, W5100_DATA0,W5100_DATA1,W5100_DATA2,W5100_DATA3,W5100_DATA4,W5100_DATA5,W5100_DATA6,W5100_DATA7 {
   }, W5100_ADDR0,W5100_ADDR1,W5100_WR   ,W5100_RD   ,W5100_CS   ,W5100_INT  ,W5100_RST  ,W5100_SEN

  BUFFER_SIZE   = 2048

VAR

  byte  macaddr[6], indent, inpre, inhtml, data[BUFFER_SIZE]
  byte  buffer[BUF_SIZE], bufptr, current_dir[128]
  byte  stkptr, last_indent, nparams
  word  tag[64], port, content_ptr, params[33], vars_addr, variables[3], content_ptr_save
  long  gateway, subnet, ip, client

OBJ

  w5100 : "Brilldea_W5100_Indirect_Driver_Ver012.spin"

PUB start(_ip, _gateway, _subnet, _mac) | tblptr, i, digit, part

  stop
  port := 0
  ip := parse_ip(_ip)
  ifnot (port)
    port := 80
  subnet := parse_ip(_subnet)
  gateway := parse_ip(_gateway)
  client := 0
  ifnot (vars_addr)
    vars_addr := @variables
  
  i~
  repeat
    case digit := byte[_mac++]
      "0" .. "9" : digit -= "0"
      "A" .. "F" : digit += 10 - "A"
      "a" .. "f" : digit += 10 - "a"
      other      : digit~~
    if (digit => 0)
      part := part << 4 | digit
      if (i++ & 1)
        macaddr[(i - 1) >> 1] := part
  until i == 12

  w5100.StartINDIRECT(W5100_DATA0, W5100_ADDR0, W5100_ADDR1, W5100_CS, W5100_RD, W5100_WR, W5100_RST, W5100_SEN)
  w5100.InitAddresses(true, @macaddr, @gateway, @subnet, @ip)
  socket_open
  return port

PUB stop

  w5100.StopINDIRECT

PUB request

  repeat until get_request
  return @data
  'return parse(@data)

PUB request0

  if (get_request)
    return @data
  else
    return false

PUB get_request : packet_size

  repeat until w5100.SocketTCPestablished(0)
    ifnot (lookdown(get_status : $14, $16, $17, $11))
      socket_reset
      return
  if (packet_size := W5100.rxTCP(0, @data))
      data[packet_size]~
      return
    
PRI get_status : status

  w5100.readIND(w5100#_S0_SR, @status, 1)

PRI parse(dataddr) | char, i, getptr, putptr

  nparams~
  repeat while ((char := byte[dataddr++]) and char <> 10 and char <> 13)
    if(lookdown(char : " ", "?", "&", "="))
      byte[dataddr - 1]~
      params[nparams++] := dataddr
  repeat i from 0 to nparams - 1
    getptr := putptr := params[i]
    repeat while getptr < putptr + strsize(putptr)
      case char := byte[getptr++]
        "+": byte[putptr++] := " "
        "%":
          repeat 2
            char := char << 4 | lookdownz(byte[getptr++] : "0" .. "9", "A" .. "F")
          byte[putptr++] := char 
        other: byte[putptr++] := char
    byte[putptr]~
  return params[0]

PUB plain_page

  _http
  str(@plain_http)

PUB custom_content

  _http

PUB not_found

  str(@error_404)
  end_all  

PRI _http

  bufptr~
  last_indent~
  str(@http)

PUB end_plain_page

  end_all

PUB end_custom_content

  end_all

PUB end_all

  flush
  socket_close    
  socket_open

PUB plain_content(straddr)

  str(straddr)
  return

PUB str(straddr)

  flush
  w5100.txTCP(0, straddr, strsize(straddr))

PUB outnz(char)

  if (char)
    out(char)
    
PUB out(char)

  if (bufptr == BUF_SIZE)
    flush
  buffer[bufptr++] := char
   
PRI flush

  if (bufptr)
    w5100.txTCP(0, @buffer, bufptr)
    bufptr~

PRI parse_ip(_ip) : retip | part, digit, char

  part~
  repeat
    if ((char := byte[_ip++]) => "0" and char =< "9")
      part := part * 10 + char - "0"
    else
      retip := retip >> 8 | (part <# 255) << 24
      part~
      if (char == 0 or char == ":")
        quit
  if (char == ":")
    repeat while (byte[_ip] => "0" and byte[_ip] =< "9")
      port := port * 10 + byte[_ip++] - "0"

PRI socket_reset

  socket_close
  socket_open

PRI socket_open

  w5100.SocketOpen(0, W5100#_TCPPROTO, port, port, @client)
  waitcnt(clkfreq / 4 + cnt)
  w5100.SocketTCPlisten(0)
  waitcnt(clkfreq / 4 + cnt)

PRI socket_close

  w5100.SocketTCPdisconnect(0)
  waitcnt(clkfreq / 40 + cnt)
  w5100.SocketClose(0)

DAT

http          byte  "HTTP/1.1 200 OK",10
              byte  "Connection: close",10
              byte  0

error_404     byte  "HTTP/1.1 404 Not Found",10
              byte  "Connection: close",10,10
              byte  0
              
plain_http    byte  "Content-type: text/plain",10,10
              byte  0
  